package it.micegroup.gestioneferie.pianificazioneferie.assembler;

import static org.springframework.hateoas.server.mvc.WebMvcLinkBuilder.linkTo;
import static org.springframework.hateoas.server.mvc.WebMvcLinkBuilder.methodOn;
import org.springframework.hateoas.CollectionModel;
import org.springframework.hateoas.Link;
import org.springframework.stereotype.Component;

import it.micegroup.gestioneferie.libs.assembler.BaseModelAssembler;
import it.micegroup.gestioneferie.pianificazioneferie.controller.DesitiRichAdesionePfController;
import it.micegroup.gestioneferie.pianificazioneferie.dto.DesitiRichAdesionePfDto;
import it.micegroup.gestioneferie.pianificazioneferie.entity.DesitiRichAdesionePf;

import it.micegroup.gestioneferie.pianificazioneferie.controller.DstatiAdesionePfController;
import it.micegroup.gestioneferie.pianificazioneferie.controller.DrichAdesionePfController;

import it.micegroup.gestioneferie.pianificazioneferie.controller.DpianificFerieAmmtoController;

@Component
public class DesitiRichAdesionePfModelAssembler
		extends BaseModelAssembler<DesitiRichAdesionePf, DesitiRichAdesionePfDto, DesitiRichAdesionePfController> {

	@Override
	public DesitiRichAdesionePfDto toModel(DesitiRichAdesionePf desitiRichAdesionePf) {
		DesitiRichAdesionePfDto desitiRichAdesionePfDto = map(desitiRichAdesionePf, DesitiRichAdesionePfDto.class,
				DesitiRichAdesionePfController.class);

		// SELF LINK
		Link selfLink = convert(linkTo(
				methodOn(DesitiRichAdesionePfController.class).getByObjectKey(desitiRichAdesionePf.getObjectKey()))
						.withSelfRel());
		desitiRichAdesionePfDto.add(selfLink);

		// PARENT LINKS
		if (desitiRichAdesionePf.getTheDstatiAdesionePf() != null) {
			Link dstatiAdesionePfLink = convert(linkTo(methodOn(DstatiAdesionePfController.class)
					.getByObjectKey(desitiRichAdesionePf.getTheDstatiAdesionePfObjectKey()))
							.withRel("theDstatiAdesionePf"));
			desitiRichAdesionePfDto.add(dstatiAdesionePfLink);
		}
		if (desitiRichAdesionePf.getTheDrichAdesionePf() != null) {
			Link drichAdesionePfLink = convert(linkTo(methodOn(DrichAdesionePfController.class)
					.getByObjectKey(desitiRichAdesionePf.getTheDrichAdesionePfObjectKey()))
							.withRel("theDrichAdesionePf"));
			desitiRichAdesionePfDto.add(drichAdesionePfLink);
		}

		// CHILDREN LINKS
		if (desitiRichAdesionePf.getTheDpianificFerieAmmto() != null) {
			Link dpianificFerieAmmtoLink = convert(linkTo(methodOn(DpianificFerieAmmtoController.class)
					.findByDesitiRichAdesionePf(desitiRichAdesionePf.getObjectKey(), null))
							.withRel("theDpianificFerieAmmto"));
			desitiRichAdesionePfDto.add(dpianificFerieAmmtoLink);
		}

		// PARENTS LINKS FOR IMPORTED MS

		// CHILDREN LINKS FOR IMPORTED MS

		return desitiRichAdesionePfDto;

	}

	@Override
	public CollectionModel<DesitiRichAdesionePfDto> toCollectionModel(
			Iterable<? extends DesitiRichAdesionePf> entities) {
		CollectionModel<DesitiRichAdesionePfDto> collectionEntities = super.toCollectionModel(entities);
		// collectionEntities.add(linkTo(methodOn(OrdineController.class).findPaginated(null,
		// null)).withSelfRel());

		return collectionEntities;
	}

}

